   .org  16509       ; REM code - relocator

;; de = fname pointer, with optional start,length;  a = operation.: 0 = load, 1-7f = delete, 80-ff = save
;;
api_fileop     .equ $1ff8

   .byte 0,1         ; 1 REM ....
   .word end-rem
   
rem:
   .byte $ea

   ; ensure RAM is paged LOW on zxpand

   ld    bc,$e007
   ld    a,$b2
   out   (c),a

   ; go FAST
 
   call $02e7

   ; move code to 8K and jump there
   
   ld    hl,start
   ld    de,$2000
   ld    bc,end-start
   ldir
   jp    $2000

start:
   ; load the required program

   ld    de,datafileload-(start-$2000)
   xor   a
   call  api_fileop

   ; patch the program

   ld    hl,PATCH-(start-$2000)
   ld    ($415d),hl

   ; start it
   ld    hl,($4002)     ; ERR-SP
   ld    sp,hl
   jp    $0207          ; SLOW/FAST



PATCH:
   call  $1ffe          ; JOYSTK
   ld    hl,$ffff

   rla
   jr    c,notup

   res   4,h
   ret

notup:
   rla
   jr    c,notdown

   res   5,h
   ret

notdown:
   rla
   jr    c,notleft

   res   3,l
   ret

notleft:
   rla
   jr    c,notright

   res   3,h
   ret

notright:
   rla
   jr    c,notfire

   res   2,h
   ret

notfire:
   call  $02bb          ; KEYBOARD
   ret

datafileload:
   ;     "FUNGALOI.P"
   .db   $2B,$3A,$33,$2C,$26,$31,$34,$2E,$1B,$35+$80

   .byte $76


end:
  
   .end
