@rem -
@rem - Compile the relocator and keyboard patches into an image which
@rem -  is a single BASIC line. This can then be inserted into a P file
@rem -  by ZXTool.
@rem - 
tasm -80 -b funpatch.asm -b temp.q

@rem -
@rem - Compile the BASIC portion of the program into a P file
@rem -
zxtext2p -l -s 10 -i 10 -o funpatch.p funpatch.txt

@rem -
@rem - Insert the machine-code REM into the P file
@rem -
zxtool funpatch.p insert

@rem -
@rem - Make the resulting file auto-run
@rem -
zxtool funpatch.p auto=10

@pause